require 'savon'
require 'active_support/core_ext'

User = 'INSERT HERE USER PROVIDED BY JUNIPER XML AGENTS'
Password = 'INSERT HERE PASS PROVIDED BY JUNIPER XML AGENTS'

AuxStartDate = Date.today + rand(4..6).months
AuxEndDate = AuxStartDate + rand(1..7).days

StartDate = AuxStartDate.strftime("%F")
EndDate = AuxEndDate.strftime("%F")

carAvailclient = Savon.client(
    wsdl: 'https://xml-uat.bookingengine.es/webservice/jp/webservicejp.asmx?wsdl', 
    endpoint: 'https://xml-uat.bookingengine.es/webservice/jp/operations/availtransactions.asmx',
    ssl_verify_mode: :none,
    log_level: :debug, 
    log: true, 
    pretty_print_xml: true,
    convert_request_keys_to: :none,
    headers: {
        "Content-Type" => "text/xml;charset=UTF-8",
        "SOAPAction" => '"http://www.juniper.es/webservice/2007/RentacarAvail"'
    }
)


OriginZone = '15011'
DestionationZone = '15011'

AdvancedOptions = {
    'ShowBreakdownPrice'=> "true",
    'TimeOut'=> "8000"
}

RentacarAvailRQ = {  
    Login: '',:attributes! => {Login: {"Password" => Password, "Email" => User}},
    Paxes: {Pax: {Age:"30"},:attributes! => { Pax: {"IdPax" => "1"}}},
    RentacarRequest: {
        SearchSegmentsRentacar: {
            SearchSegmentRentacar: {CountryOfResidence:"ES", AgeDriver: "30"}, 
            :attributes! => { SearchSegmentRentacar: {"Start" => StartDate, "End" => EndDate, "OriginZone" => OriginZone, "DestinationZone" => DestionationZone, "Hour" => "10:00:00", "HourEnd" => "10:00:00"}}

        }
    },
    AdvancedOptions: AdvancedOptions
}

carAvailclient.call(:rentacar_avail, message: {
    RentacarAvailRQ: RentacarAvailRQ, 
    :attributes! => {
        RentacarAvailRQ: {
            "Version" => "1.1",
            "Language" => "EN"
        }
    }
})